
Database - Feature #2128

Feature # 1651 (Closed): add support for dynamic database features

Feature # 1652 (Closed): add conversion and runtime support for dynamically prepared temp-tables

generate and load DMO interface and implementation classes for dynamic temp-tables at runtime

04/23/2013 12:18 PM - Eric Faulhaber

Status: Closed Start date: 05/13/2013

Priority: Normal Due date: 06/03/2013

Assignee: Stanislav Lomany % Done: 100%

Category:  Estimated time: 120.00 hours

Target version: Runtime Support for Server Features   

billable: No vendor_id: GCD

Description

History

#1 - 04/23/2013 12:32 PM - Eric Faulhaber

Based on information provided by runtime methods to define and prepare a dynamically generated temp-table, we need to generate a DMO interface

and a DMO implementation class, and to load these with a custom class loader at runtime.  The proposed approach:

use the information provided by converted 4GL methods for defining a temp-table to generate a .dict-compatible AST (also need to persist this

for use with dynamically defined queries as noted in #1652);

execute TRPL in the P2J runtime to run schema conversion against this AST, ultimately creating Java source code for the interface and class;

adapt the in-memory Java compilation and class-loading technique used in the regression test harness to load the interface and class into the

JVM.

The custom classloader also will need to be able to unload the interface and class when no longer in use.  We should implement this ability in the

classloader, but implementing the associated logic to determine when this code is appropriate to unload can be deferred to M11.

#2 - 04/25/2013 03:15 PM - Eric Faulhaber

- Due date set to 06/03/2013

- Assignee set to Ovidiu Maxiniuc

- Start date set to 05/13/2013

This issue is closely related to its sibling issue, #2122.  I have split these into two, because the parent feature is important to get done as early as

possible, and I think they can be worked in parallel.

Stanislav and Ovidiu:  please use the parent issue history to coordinate closely, to ensure a minimum overlap of effort, but post your time to the

individual issues.

#3 - 06/25/2013 03:49 PM - Eric Faulhaber

- Assignee changed from Ovidiu Maxiniuc to Stanislav Lomany

#4 - 09/25/2013 05:34 PM - Eric Faulhaber
https://proj.goldencode.com/issues/1652
https://proj.goldencode.com/issues/2122


- Status changed from New to Review

- % Done changed from 0 to 70

#5 - 12/05/2013 03:55 PM - Eric Faulhaber

- % Done changed from 70 to 100

- Status changed from Review to Closed

#6 - 11/16/2016 11:43 AM - Greg Shah

- Target version changed from Milestone 7 to Runtime Support for Server Features
